
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>C 和 C++ 文件操作详解 / iVAN</title>

    <meta name="description" content="C 和 C++ 文件操作详解 来源:http://www.cnblogs.com/likebeta/archive/2012/06/16/2551662.html 来源:http://www.cnblogs.com/likebeta/archive/2012/06/16/2551780.html C++的文件操作 在C++中,有一个stream这个类,所有的I/O都以这个&quot;流&quot;类为基础的,包括我们要认识的文件I/O,stream这个类有两个重要的运算符: 1.插入器(&lt;&lt;) 向流输出数据.比如 ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">C 和 C++ 文件操作详解</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>来源：<a href="http://www.cnblogs.com/likebeta/archive/2012/06/16/2551662.html" rel="external nofollow noreferrer">http://www.cnblogs.com/likebeta/archive/2012/06/16/2551662.html</a></p>
<p>来源：<a href="http://www.cnblogs.com/likebeta/archive/2012/06/16/2551780.html" rel="external nofollow noreferrer">http://www.cnblogs.com/likebeta/archive/2012/06/16/2551780.html</a></p>
<h1><strong>C++的文件操作</strong></h1>
<p>在C++中，有一个stream这个类，所有的I/O都以这个“流”类为基础的，包括我们要认识的文件I/O，stream这个类有两个重要的运算符：</p>
<p>1、插入器(&lt;&lt;)<br />
　　向流输出数据。比如说系统有一个默认的标准输出流(cout)，一般情况下就是指的显示器，所以，cout&lt;&lt;"Write Stdout"&lt;&lt;''\n'';就表示把字符串"Write Stdout"和换行字符(''\n'')输出到标准输出流。</p>
<p>2、析取器(&gt;&gt;)<br />
　　从流中输入数据。比如说系统有一个默认的标准输入流(cin)，一般情况下就是指的键盘，所以，cin&gt;&gt;x;就表示从标准输入流中读取一个指定类型(即变量x的类型)的数据。<br />
　　在C++中，对文件的操作是通过stream的子类fstream(file stream)来实现的，所以，要用这种方式操作文件，就必须加入头文件fstream.h。</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNzAzMDkxNDI4MTA1MzE/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2Wm5KbFpXdHBibWN4TURFPS9mb250LzVhNkw1TDJUL2ZvbnRzaXplLzQwMC9maWxsL0kwSkJRa0ZDTUE9PS9kaXNzb2x2ZS83MC9ncmF2aXR5L0NlbnRlcg==.jpg"></p>
<p>C++ 通过以下几个类支持文件的输入输出：</p>
<ul>
<li>ofstream: 写操作（输出）的文件类 (由ostream引申而来)</li>
<li>ifstream: 读操作（输入）的文件类(由istream引申而来)</li>
<li>fstream: 可同时读写操作的文件类 (由iostream引申而来)</li>
</ul>
<h2>打开文件(Open a file)</h2>
<p>对这些类的一个对象所做的第一个操作通常就是将它和一个真正的文件联系起来，也就是说打开一个文件。被打开的文件在程序中由一个流对象(stream object)来表示 (这些类的一个实例) ，而对这个流对象所做的任何输入输出操作实际就是对该文件所做的操作。</p>
<p><strong>1. 通过一个流对象调用open函数打开一个文件。</strong>我们使用它的成员函数open()：void open (const char * filename, openmode mode);</p>
<p>这里filename 是一个字符串，代表要打开的文件名，mode 是以下标志符的一个组合： ios::in 为输入(读)而打开文件</p>
<p><strong>文件的输入输出是从内存的角度看的：数据载入内存叫做输入，数据从内存到其他地方叫做输出。</strong></p>
<ul>
<li>ios::out 文件以输出(写)方式打开 </li>
<li>ios::in    文件以输入(读)方式打开</li>
<li>ios::ate 初始位置：文件尾</li>
<li>ios::app 所有输出附加在文件末尾</li>
<li>ios::trunc 如果文件已存在则先删除该文件</li>
<li>ios::binary 二进制方式</li>
</ul>
<p>这些标识符可以被组合使用，中间以”或”操作符(|)间隔。例如，如果我们想要以二进制方式打开文件”example.bin” 来写入一些数据，我们可以通过以下方式调用成员函数open（）来实现：</p>
<pre>ofstream file;
file.open ("example.bin", ios::out | ios::app | ios::binary);</pre>
<p>ofstream, ifstream 和 fstream所有这些类的成员函数open 都包含了一个默认打开文件的方式，这三个类的默认方式各不相同： 类 参数的默认方式</p>
<ul>
<li>ofstream ios::out | ios::trunc</li>
<li>ifstream ios::in</li>
<li>fstream ios::in | ios::out</li>
</ul>
<p>只有当函数被调用时没有声明方式参数的情况下，默认值才会被采用。如果函数被调用时声明了任何参数，默认值将被完全改写，而不会与调用参数组合。</p>
<p><strong>2. 通过类对象构造函数打开文件。</strong>类ofstream,<br />
 ifstream 和 fstream 的对象所进行的第一个操作通常都是打开文件，这些类都有一个构造函数可以直接调用open 函数，并拥有同样的参数。这样，我们就可以通过以下方式进行与上面同样的定义对象和打开文件的操作：
<pre>ofstream file ("example.bin", ios::out | ios::app | ios::binary);
例如：以二进制输入方式打开文件c:\config.sys
fstream file1;
file1.open("c:\\config.sys",ios::binary|ios::in,0);

//如果open函数只有文件名一个参数，则是以读/写普通文件打开，即：
file1.open("c:\\config.sys");&lt;=&gt;file1.open("c:\\config.sys",ios::in|ios::out,0);

//另外，fstream还有和open()一样的构造函数，对于上例，在定义的时侯就可以打开文件了：
fstream file1("c:\\config.sys");</pre>
<p><strong>以上 两种 打开文件的方式都是正确的。</strong></p>
<p>通过调用成员函数is_open()来检查一个文件是否已经被顺利的打开：bool is_open()。它返回一个布尔(bool)值，为真（true）代表文件已经被顺利打开，假( false )则相反。</p>
<pre>#include &lt;fstream&gt;
ofstream //文件写操作 内存写入存储设备
ifstream //文件读操作，存储设备读区到内存中
fstream //读写操作，对打开的文件可进行读写操作</pre>
<p>在fstream类中，成员函数open（）实现打开文件的操作，从而将数据流和文件进行关联，通过ofstream,ifstream,fstream对象 进行对文件的读写操作</p>
<p>在fstream类中，有一个成员函数open()，就是用来打开文件的，其原型是：</p>
<p>void open(const char* filename,int mode,int access);</p>
<p>参数：</p>
<pre>filename： 要打开的文件名
mode： 要打开文件的方式
access： 打开文件的属性</pre>
<p>打开文件的方式在类ios(是所有流式I/O类的基类)中定义，常用的值如下：
<pre>ios::app： 以追加的方式打开文件
ios::ate： 文件打开后定位到文件尾，ios:app就包含有此属性
ios::binary： 以二进制方式打开文件，缺省的方式是文本方式。两种方式的区别见前文
ios::in： 文件以输入(读)方式打开
ios::out： 文件以输出(写)方式打开
ios::nocreate： 不建立文件，所以文件不存在时打开失败
ios::noreplace：不覆盖文件，所以打开文件时如果文件存在失败
ios::trunc： 如果文件存在，把文件长度设为0。即删除该文件。</pre>
<p>可以用“或”把以上属性连接起来，如ios::out|ios::binary</p>
<pre>ofstream out;
out.open("Hello.txt", ios::in|ios::out|ios::binary)     //根据自己需要进行适当的选取 </pre>
<p>打开文件的属性取值是：
<pre>0：普通文件，打开访问
1：只读文件
2：隐含文件
4：系统文件</pre>
<p>可以用“或”或者“+”把以上属性连接起来 ，如3或1|2就是以只读和隐含属性打开文件。</p>
<p>例如：以二进制输入方式打开文件c:config.sys</p>
<pre>fstream file1;
file1.open("c:config.sys",ios::binary|ios::in,0);
// 如果open函数只有文件名一个参数，则是以读/写普通文件打开，即：
// file1.open("c:config.sys");&lt;=&gt;file1.open("c:config.sys",ios::in|ios::out,0);
// 另外，fstream还有和open()一样的构造函数，对于上例，在定义的时侯就可以打开文件了：
fstream file1("c:config.sys");
// fstream有两个子类：ifstream(input file stream)和ofstream(outpu file stream)，ifstream默认以输入方式打开文件，而ofstream默认以输出方式打开文件。
ifstream file2("c:pdos.def");//以输入方式打开文件
ofstream file3("c:x.123");//以输出方式打开文件
</pre>
<p>所以，在实际应用中，根据需要的不同，选择不同的类来定义：如果想以输入方式打开，就用ifstream来定义；如果想以输出方式打开，就用ofstream来定义；如果想以输入/输出方式来打开，就用fstream来定义。很多程序中，可能会碰到ofstream out("Hello.txt"), ifstream in("..."),fstream foi("...")这样的的使用，并没有显式的去调用open（）函数就进行文件的操作，直接调用了其默认的打开方式，因为在stream类的构造函数中调用了open()函数,并拥有同样的构造函数，所以在这里可以直接使用流对象进行文件的操作，默认方式如下：
<pre>ofstream out("...", ios::out);
ifstream in("...", ios::in);
fstream foi("...", ios::in|ios::out); </pre>
<p>当使用默认方式进行对文件的操作时，你可以使用成员函数is_open()对文件是否打开进行验证</p>
<h2>关闭文件(Closing a file)</h2>
<p>当文件读写操作完成之后，我们必须将文件关闭以使文件重新变为可访问的。关闭文件需要调用成员函数close()，它负责将缓存中的数据排放出来并关闭文件。<br />
void close ();    这个函数一旦被调用，原先的流对象(stream object)就可以被用来打开其它的文件了，这个文件也就可以重新被其它的进程(process)所有访问了。<br />
为防止流对象被销毁时还联系着打开的文件，析构函数(destructor)将会自动调用关闭函数close。</p>
<p>打开的文件使用完成后一定要关闭，fstream提供了成员函数close()来完成此操作，如：file1.close();就把file1相连的文件关闭。</p>
<h2>读写文件</h2>
<p>读写文件分为文本文件和二进制文件的读取，对于文本文件的读取比较简单，用插入器和析取器就可以了；而对于二进制的读取就要复杂些，</p>
<p>下要就详细的介绍这两种方式</p>
<h3>文本文件(Text mode files)</h3>
<p>类ofstream, ifstream 和fstream 是分别从ostream, istream 和iostream 中引申而来的。这就是为什么 fstream 的对象可以使用其父类的成员来访问数据。<br />
一般来说，我们将使用这些类与同控制台(console)交互同样的成员函数(cin 和 cout)来进行输入输出。如下面的例题所示，我们使用重载的插入操作符</p>
<p>文本文件的读写很简单：用插入器(&gt;&gt;)从文件输入。假设file1是以输入方式打开，file2以输出打开。示例如下：</p>
<pre>file2&lt;&lt;"I Love You";//向文件写入字符串"I Love You"
int i;
file1&gt;&gt;i;//从文件输入一个整数值。</pre>
<p>这种方式还有一种简单的格式化能力，比如可以指定输出为16进制等等，具体的格式有以下一些</p>
<p>操纵符 功能 输入/输出<br />
dec 格式化为十进制数值数据 输入和输出<br />
endl 输出一个换行符并刷新此流 输出<br />
ends 输出一个空字符 输出<br />
hex 格式化为十六进制数值数据 输入和输出<br />
oct 格式化为八进制数值数据 输入和输出<br />
setpxecision(int p) 设置浮点数的精度位数 输出</p>
<p>比如要把123当作十六进制输出：file1&lt;&lt;hex&lt;&lt;123;要把3.1415926以5位精度输出：file1&lt;&lt;setpxecision(5)&lt;&lt;3.1415926。</p>
<p>类ofstream, ifstream 和fstream 是分别从ostream, istream 和iostream 中引申而来的。这就是为什么 fstream 的对象可以使用其父类的成员来访问数据。<br />
一般来说，我们将使用这些类与同控制台(console)交互同样的成员函数(cin 和 cout)来进行输入输出。如下面的例题所示，我们使用重载的插入操作符&lt;&lt;：</p>
<pre>// writing on a text file
 #include &lt;fiostream.h&gt;
 int main () {
   ofstream out("out.txt");
   if (out.is_open())
  {
     out &lt;&lt; "This is a line.\n";
     out &lt;&lt; "This is another line.\n";
     out.close();
   }
   return 0;
 }
//结果: 在out.txt中写入：
This is a line.
This is another line
从文件中读入数据也可以用与 cin&gt;&gt;的使用同样的方法：
// reading a text file
  #include &lt;iostream.h&gt;
  #include &lt;fstream.h&gt;
  #include &lt;stdlib.h&gt; 

  int main () {
    char buffer[256];
    ifstream in("test.txt");
    if (! in.is_open())
    { cout &lt;&lt; "Error opening file"; exit (1); }
    while (!in.eof() )
    {
      in.getline (buffer,100);
      cout &lt;&lt; buffer &lt;&lt; endl;
    }
    return 0;
  }
  //结果 在屏幕上输出
  This is a line.
  This is another line</pre>
<p>例子中读入一个文本文件的内容，然后将它打印到屏幕上。注意我们使用了一个新的成员函数叫做eof ，它是ifstream 从类 ios 中继承过来的，当到达文件末尾时返回true 。</p>
<h3>二进制文件(Binary files)</h3>
<p>在二进制文件中，使用&lt;&lt; 和&gt;&gt;，以及函数（如getline）来操作符输入和输出数据，没有什么实际意义，虽然它们是符合语法的。</p>
<p>文件流包括两个为顺序读写数据特殊设计的成员函数：write 和 read。第一个函数 (write) 是ostream 的一个成员函数，都是被ofstream所继承。而read 是istream 的一个成员函数，被ifstream 所继承。类 fstream 的对象同时拥有这两个函数。它们的原型是：</p>
<p>write ( char * buffer, streamsize size );<br />
read ( char * buffer, streamsize size );</p>
<p>这里 buffer 是一块内存的地址，用来存储或读出数据。参数size 是一个整数值，表示要从缓存（buffer）中读出或写入的字符数。</p>
<pre>// reading binary file
#include &lt;iostream&gt;
#include &lt;fstream&gt;
using namespace std;
int main ()
{
    const char * filename = "example.txt";
    char * buffer;
    long size;
    ifstream file(filename, ios::in|ios::binary|ios::ate);
    size = file.tellg();
    file.seekg(0, ios::beg);
    buffer = new char [size];
    file.read(buffer, size);
    file.close();
    cout &lt;&lt;"the complete file is in a buffer";
    delete[] buffer;
    return 0;
}
//The complete file is in a buffer</pre>
<p>①put()</p>
<p>put()函数向流写入一个字符，其原型是ofstream &amp;put(char ch)，使用也比较简单，如file1.put(‘c’);就是向流写一个字符’c’。</p>
<p>②get()</p>
<p>get()函数比较灵活，有3种常用的重载形式：</p>
<p>一种就是和put()对应的形式：ifstream &amp;get(char &amp;ch);功能是从流中读取一个字符，结果保存在引用ch中，如果到文件尾，返回空字符。如file2.get(x);表示从文件中读取一个字符，并把读取的字符保存在x中。</p>
<p>另一种重载形式的原型是： int get();这种形式是从流中返回一个字符，如果到达文件尾，返回EOF，如x=file2.get();和上例功能是一样的。</p>
<p>还 有一种形式的原型是：ifstream &amp;get(char *buf,int num,char delim=’n’)；这种形式把字符读入由 buf 指向的数组，直到读入了 num 个字符或遇到了由 delim 指定的字符，如果没使用 delim 这个参数，将使用缺省值换行符’n’。例如：</p>
<p>file2.get(str1,127,’A’);//从文件中读取字符到字符串str1，当遇到字符’A’或读取了127个字符时终止。</p>
<p>③读写数据块</p>
<p>要读写二进制数据块，使用成员函数read()和write()成员函数，它们原型如下：</p>
<p>read(unsigned char *buf,int num);<br />
write(const unsigned char *buf,int num);<br />
read() 从文件中读取 num 个字符到 buf 指向的缓存中，如果在还未读入 num 个字符时就到了文件尾，可以用成员函数 int gcount();来取得实际读取的字符数；而 write() 从buf 指向的缓存写 num 个字符到文件中，值得注意的是缓存的类型是 unsigned char *，有时可能需要类型转换。</p>
<pre>unsigned char str1[]="I Love You";
int n[5];
ifstream in("xxx.xxx");
ofstream out("yyy.yyy");
out.write(str1,strlen(str1));//把字符串str1全部写到yyy.yyy中
in.read((unsigned char*)n,sizeof(n));//从xxx.xxx中读取指定个整数，注意类型转换
in.close();out.close();</pre>
<h2>状态标志符的验证(Verification of state flags)</h2>
<p>除了eof()以外，还有一些验证流的状态的成员函数（所有都返回bool型返回值）：</p>
<p>bad()：如果在读写过程中出错，返回 true 。例如：当我们要对一个不是打开为写状态的文件进行写入时，或者我们要写入的设备没有剩余空间的时候。<br />
fail()：除了与bad() 同样的情况下会返回 true 以外，加上格式错误时也返回true ，例如当想要读入一个整数，而获得了一个字母的时候。<br />
eof()：如果读文件到达文件末尾，返回true。<br />
good()：这是最通用的：如果调用以上任何一个函数返回true 的话，此函数返回 false 。</p>
<p>要想重置以上成员函数所检查的状态标志，你可以使用成员函数clear()，没有参数。</p>
<h2>缓存和同步(Buffers and Synchronization)</h2>
<p>当我们对文件流进行操作的时候，它们与一个streambuf 类型的缓存(buffer)联系在一起。这个缓存（buffer）实际是一块内存空间，作为流(stream)和物理文件的媒介。例如，对于一个输出流， 每次成员函数put (写一个单个字符)被调用，这个字符不是直接被写入该输出流所对应的物理文件中的，而是首先被插入到该流的缓存（buffer）中。</p>
<p>当缓存被排放出来(flush)时，它里面的所有数据或者被写入物理媒质中（如果是一个输出流的话），或者简单的被抹掉(如果是一个输入流的话)。这个过程称为同步(synchronization)，它会在以下任一情况下发生：</p>
<p>1. 当文件被关闭时: 在文件被关闭之前，所有还没有被完全写出或读取的缓存都将被同步。<br />
2. 当缓存buffer 满时:缓存Buffers 有一定的空间限制。当缓存满时，它会被自动同步。<br />
3. 控制符明确指明:当遇到流中某些特定的控制符时，同步会发生。这些控制符包括：flush 和endl。<br />
4. 明确调用函数sync(): 调用成员函数sync() (无参数)可以引发立即同步。这个函数返回一个int 值，等于-1 表示流没有联系的缓存或操作失败</p>
<h2>检测 EOF</h2>
<p>成员函数eof()用来检测是否到达文件尾，如果到达文件尾返回非0值，否则返回0。原型是int eof();</p>
<p>if(in.eof())ShowMessage("已经到达文件尾！");</p>
<h2>文件定位</h2>
<p>和 C的文件操作方式不同的是，C++ I/O系统管理两个与一个文件相联系的指针。一个是读指针，它说明输入操作在文件中的位置；另一个是写指针，它下次写操作的位置。每次执行输入或输出时， 相应的指针自动变化。所以，C++的文件定位分为读位置和写位置的定位，对应的成员函数是 seekg()和 seekp()，seekg()是设置读位置，seekp是设置写位置。它们最通用的形式如下：</p>
<pre>istream &amp;seekg(streamoff offset,seek_dir origin);
ostream &amp;seekp(streamoff offset,seek_dir origin);</pre>
<p>streamoff定义于 iostream.h 中，定义有偏移量 offset 所能取得的最大值，seek_dir 表示移动的基准位置，是一个有以下值的枚举：</p>
<pre>ios::beg： 文件开头
ios::cur： 文件当前位置
ios::end： 文件结尾</pre>
<p>这两个函数一般用于二进制文件，因为文本文件会因为系统对字符的解释而可能与预想的值不同。
<pre>file1.seekg(1234,ios::cur);//把文件的读指针从当前位置向后移1234个字节
file2.seekp(1234,ios::beg);//把文件的写指针从文件开头向后移1234个字节</pre>
<p><strong>获得和设置流指针(get and put stream pointers)</strong></p>
<p>所有输入/输出流对象(i/o streams objects)都有至少一个流指针：<br />
<br />ifstream， 类似istream, 有一个被称为get pointer的指针，指向下一个将被读取的元素。<br />
ofstream, 类似 ostream, 有一个指针 put pointer ，指向写入下一个元素的位置。<br />
fstream, 类似 iostream, 同时继承了get 和 put<br />
我们可以通过使用以下成员函数来读出或配置这些指向流中读写位置的流指针：</p>
<p>tellg() 和 tellp()</p>
<p>这两个成员函数不用传入参数，返回pos_type 类型的值(根据ANSI-C++ 标准) ，就是一个整数，代表当前get 流指针的位置 (用tellg) 或 put 流指针的位置(用tellp).<br />
seekg() 和seekp()</p>
<p>这对函数分别用来改变流指针get 和put的位置。两个函数都被重载为两种不同的原型：</p>
<pre>seekg ( pos_type position );
seekp ( pos_type position );</pre>
<p>使用这个原型，流指针被改变为指向从文件开始计算的一个绝对位置。要求传入的参数类型与函数 tellg 和tellp 的返回值类型相同。
<pre>seekg ( off_type offset, seekdir direction );
seekp ( off_type offset, seekdir direction );</pre>
<p>使用这个原型可以指定由参数direction决定的一个具体的指针开始计算的一个位移(offset)。它可以是：
<pre>ios::beg 从流开始位置计算的位移
ios::cur 从流指针当前位置开始计算的位移
ios::end 从流末尾处开始计算的位移</pre>
<p>流指针 get 和 put 的值对文本文件(text file)和二进制文件(binary file)的计算方法都是不同的，因为文本模式的文件中某些特殊字符可能被修改。由于这个原因，建议对以文本文件模式打开的文件总是使用seekg 和 seekp的第一种原型，而且不要对tellg 或 tellp 的返回值进行修改。对二进制文件，你可以任意使用这些函数，应该不会有任何意外的行为产生。</p>
<p>以下例子使用这些函数来获得一个二进制文件的大小：</p>
<pre>// obtaining file size
#include &lt;iostream&gt;
#include &lt;fstream&gt;
using namespace std;

int main ()
{
    const char * filename = "example.txt";
    long l,m;
    ifstream file(filename, ios::in|ios::binary);
    l = file.tellg();
    file.seekg(0, ios::end);
    m = file.tellg();
    file.close();
    cout &lt;&lt;"size of "&lt;&lt; filename;
    cout &lt;&lt;" is "&lt;&lt; (m-l)&lt;&lt;" bytes.\n";
    return 0;
}
//size of example.txt is 40 bytes.</pre>
<h1>C语言文件操作详解</h1>
<p><strong>基于C的文件操作</strong></p>
<p>在ANSI C中，对文件的操作分为两种方式，即流式文件操作和I/O文件操作，下面就分别介绍之。</p>
<p>一、流式文件操作：这种方式的文件操作有一个重要的结构FILE，FILE在stdio.h中定义如下：</p>
<pre>typedef struct
{
    short           level;          /* fill/empty level of buffer */
    unsigned        flags;          /* File status flags    */
    char            fd;             /* File descriptor      */
    unsigned char   hold;           /* Ungetc char if no buffer */
    short           bsize;          /* Buffer size          */
    unsigned char   *buffer;        /* Data transfer buffer */
    unsigned char   *curp;          /* Current active pointer */
    unsigned        istemp;         /* Temporary file indicator */
    short           token;          /* Used for validity checking */
}FILE;    /* This is the FILE object */
FILE这个结构包含了文件操作的基本属性，对文件的操作都要通过这个结构的指针来进行。</pre>
<p>C语言中没有输入输出语句，所有的输入输出功能都用 ANSI C提供的一组标准库函数来实现。文件操作标准库函数有：</p>
<pre>　　 　　 文件的打开操作 fopen 打开一个文件
　　 　　 文件的关闭操作 fclose 关闭一个文件
　　 　　 文件的读写操作 fgetc 从文件中读取一个字符
　　 　　 　　　　　　　 fputc 写一个字符到文件中去
　　 　　 　　　　　　　 fgets 从文件中读取一个字符串
　　 　　 　　　　　　　 fputs 写一个字符串到文件中去
　　 　　 　　　　　　　 fprintf 往文件中写格式化数据
　　 　　 　　　　　　　 fscanf 格式化读取文件中数据
　　 　　 　　　　　　　 fread 以二进制形式读取文件中的数据
　　 　　 　　　　　　　 fwrite 以二进制形式写数据到文件中去
　　 　　 　　　　　　　 getw 以二进制形式读取一个整数
　　 　　 　　　　　　　 putw 以二进制形式存贮一个整数
　　 　文件状态检查函数  feof 文件结束
　　 　　 　　　　　　　 ferror 文件读/写出错
　　 　　 　　　　　　　 clearerr 清除文件错误标志
　　 　　 　　　　　　　 ftell 了解文件指针的当前位置

　　　          文件定位函数 rewind 反绕
　　 　　 　　　　　　　 fseek 随机定位</pre>
<p><h2>文件的打开</h2>
<p>　1．函数原型：<strong>FILE *fopen(char *pname,char *mode)</strong></p>
<p>　2．功能说明<br />
　　 按照mode 规定的方式，打开由pname指定的文件。若找不到由pname指定的相应文件，就按以下方式之一处理：<br />
       （1） 此时如mode 规定按写方式打开文件，就按由pname指定的名字建立一个新文件；<br />
       （2） 此时如mode 规定按读方式打开文件，就会产生一个错误。</p>
<p>        打开文件的作用是：<br />
        （1）分配给打开文件一个FILE 类型的文件结构体变量，并将有关信息填入文件结构体变量；<br />
        （2）开辟一个缓冲区；<br />
        （3）调用操作系统提供的打开文件或建立新文件功能，打开或建立指定文件；<br />
        FILE *：指出fopen是一个返回文件类型的指针函数；</p>
<p>　3．参数说明</p>
<pre>pname：是一个字符指针，指向要打开的文件名。
mode：是一个指向文件处理方式字符串的字符指针。
字符串 含义
"r" 打开只读文件，该文件必须存在。
"w" 打开只写文件，若文件存在则文件长度清为0，即该文件内容会消失。若文件不存在则建立该文件。
"a" 以追加方式打开只写文件。文件不存在建立该文件，如文件存在，写入的数据会被加到文件尾，即文件原先的内容会被保留。
"r+" 以读/写方式打开文件，该文件必须存在。如无文件则出错
"w+" 以读/写方式打开文件，若文件存在则文件长度清为零，即文件内容清空。若文件不存在则建立该文件。</pre>
<p>上述的形态字符串都可以再加一个b字符，如rb、w+b或ab＋等组合，加入b 字符用来告诉函数库打开的文件为二进制文件，而非纯文字文件。不过在POSIX系统，包含Linux都会忽略该字符。由fopen()所建立的新文件会具有S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP|S_IROTH|S_IWOTH(0666)权限，此文件权限也会参考umask值。<br />
返回值 文件顺利打开后，指向该流的文件指针就会被返回。若果文件打开失败则返回NULL，并把错误代码存在errno 中。<br />
附加说明 一般而言，开文件后会作一些文件读取或写入的动作，若开文件失败，接下来的读写动作也无法顺利进行，所以在fopen()后请作错误判断及处理。</p>
<p>　　一个文件可以以文本模式或二进制模式打开，这两种的区别是：在文本模式中回车被当成一个字符''\n''，而二进制模式认为它是两个字符0x0D,0x0A；如果在文件中读到0x1B，文本模式会认为这是文件结束符，也就是二进制模型不会对文件进行处理，而文本方式会按一定的方式对数据作相应的转换。</p>
<p>　　系统默认的是以文本模式打开，可以修改全部变量_fmode的值来修改这个设置，例如_fmode=O_TEXT；就设置默认打开方式为文本模式；而_fmode=O_BINARY；则设置默认打开方式是二进制模式。<br />
　　我们也可以在模式字符串中指定打开的模式，如"rb"表示以二进制模式打开只读文件，"w+t"或"wt+"表示以文本模式打开读/写文件。<br />
　　此函数返回一个FILE指针，所以申明一个FILE指针后不用初始化，而是用fopen()来返回一个指针并与一个特定的文件相连，如果成败，返回NULL。</p>
<p>　4．返回值<br />
　　　正常返回：被打开文件的文件指针。<br />
　　　异常返回：NULL，表示打开操作不成功。</p>
<pre>//定义一个名叫fp文件指针
FILE *fp；
//判断按读方式打开一个名叫test的文件是否失败
if((fp=fopen（"test"，"r"）) == NULL)//打开操作不成功
{
    printf("The file can not be opened.\n")；    　
    exit(1);//结束程序的执行
}
FILE *fp;
if(fp=fopen("123.456","wb"))
    puts("打开文件成功");
else
    puts("打开文件成败");</pre>
<p>要说明的是：<strong>C语言将计算机的输入输出设备都看作是文件。例如，键盘文件、屏幕文件等。ANSI C标准规定，在执行程序时系统先自动打开键盘、屏幕、错误三个文件。这三个文件的文件指针分别是：标准输入stdin、标准输出stdout和标准出错 stderr。</strong></p>
<p><strong>freopen（打开文件）</strong></p>
<p>相关函数 fopen，fclose<br />
表头文件 #include&lt;stdio.h&gt;<br />
定义函数<strong> FILE * freopen(const char * path,const char * mode,FILE * stream);</strong><br />
函数说明 参数path字符串包含欲打开的文件路径及文件名，参数mode请参考fopen()说明。参数stream为已打开的文件指针。Freopen()会将原stream所打开的文件流关闭，然后打开参数path的文件。<br />
返回值 文件顺利打开后，指向该流的文件指针就会被返回。如果文件打开失败则返回NULL，并把错误代码存在errno 中。</p>
<pre>#include&lt;stdio.h&gt;
main()
{
FILE * fp;
fp=fopen(“/etc/passwd”,”r”);
fp=freopen(“/etc/group”,”r”,fp);
fclose(fp);
}</pre>
<h2>文件的关闭</h2>
<p>1． 函数原型：<strong>int fclose(FILE *fp)；</strong></p>
<p>2． 功能说明<br />
　　关闭由fp指出的文件。此时调用操作系统提供的文件关闭功能，关闭由fp-&gt;fd指出的文件；释放由fp指出的文件类型结构体变量；返回操作结果，即0或EOF。</p>
<p>3． 参数说明<br />
　　fp：一个已打开文件的文件指针。</p>
<p>4． 返回值<br />
　　正常返回：0。<br />
　　异常返回：EOF，表示文件在关闭时发生错误。<br />
例如：</p>
<pre>int n=fclose(fp);</pre>
<h2>文件的读写操作</h2>
<h3>1. 从文件中读取一个字符</h3>
<p>　　1． 函数原型：<strong>int fgetc(FILE *fp)；</strong></p>
<p>　　2． 功能说明：从fp所指文件中读取一个字符。　　　</p>
<p>　　3． 参数说明：fp：这是个文件指针，它指出要从中读取字符的文件。　　　</p>
<p>　　4． 返回值<br />
　　　　正常返回： 返回读取字符的代码。<br />
　　　　非正常返回：返回EOF。例如，要从"写打开"文件中读取一个字符时，会发生错误而返回一个EOF。</p>
<pre>//显示指定文件的内容。

//程序名为：display.c
//执行时可用：display filename1 形式的命令行运行。显示文件filename1中的内容。例如，执行命令行display display.c将在屏幕上显示display的原代码。

//File display program.
#include &lt;stdio.h&gt;
void main(int argc,char *argv[]) //命令行参数
{
    int ch;//定义文件类型指针
    FILE *fp;//判断命令行是否正确
    if(argc!=2)
    {
        printf("Error format,Usage: display filename1\n");
        return; //键入了错误的命令行，结束程序的执行
    }
    //按读方式打开由argv[1]指出的文件
    if((fp=fopen(argv[1],"r"))==NULL)
    {
        printf("The file &lt;%s&gt; can not be opened.\n",argv[1]);//打开操作不成功
        return;//结束程序的执行
    }
    //成功打开了argv[1]所指文件
    ch=fgetc(fp); //从fp所指文件的当前指针位置读取一个字符
    while(ch!=EOF) //判断刚读取的字符是否是文件结束符
    {
        putchar(ch); //若不是结束符，将它输出到屏幕上显示
        ch=fgetc(fp); //继续从fp所指文件中读取下一个字符
    } //完成将fp所指文件的内容输出到屏幕上显示
    fclose(fp); //关闭fp所指文件
}</pre>
<h3>2. 写一个字符到文件中去</h3>
<p>1． 函数原型：<strong>int fputc(int ch,FILE *fp)</strong><br />
<br />2． 功能说明：把ch中的字符写入由fp指出的文件中去。　</p>
<p>3． 参数说明<br />
　　ch：是一个整型变量，内存要写到文件中的字符（C语言中整型量和字符量可以通用）。<br />
　　fp：这是个文件指针，指出要在其中写入字符的文件。</p>
<p>4． 返回值<br />
　　正常返回： 要写入字符的代码。<br />
　　非正常返回：返回EOF。例如，要往"读打开"文件中写一个字符时，会发生错误而返回一个EOF。</p>
<pre>//将一个文件的内容复制到另一个文件中去。

//程序名为：copyfile.c
//执行时可用：copyfile filename1 filename2形式的命令行运行，将文件filename1中的内容复制到文件filename2中去。
//file copy program.
#include &lt;stdio.h&gt;
void main(int argc,char *argv[]) //命令行参数
{
    int ch;
    FILE *in,*out; //定义in和out两个文件类型指针
    if(argc!=3) //判断命令行是否正确
    {
        printf("Error in format,Usage: copyfile filename1 filename2\n");
        return; //命令行错，结束程序的执行
    }
    //按读方式打开由argv[1]指出的文件
    if((in=fopen(argv[1],"r"))==NULL)
    {
        printf("The file &lt;%s&gt; can not be opened.\n",argv[1]);
        return; //打开失败，结束程序的执行
    }
    //成功打开了argv[1]所指文件，再
    //按写方式打开由argv[2]指出的文件
    if((out=fopen(argv[2],"w"))==NULL)
    {
        printf("The file %s can not be opened.\n",argv[2]);
        return; //打开失败，结束程序的执行
    }
    //成功打开了argv[2]所指文件
    ch=fgetc(in); //从in所指文件的当前指针位置读取一个字符
    while(ch!=EOF) //判断刚读取的字符是否是文件结束符
    {
        fputc(ch,out); //若不是结束符，将它写入out所指文件
        ch=fgetc(in); //继续从in所指文件中读取下一个字符
    } //完成将in所指文件的内容写入（复制）到out所指文件中
    fclose(in); //关闭in所指文件
    fclose(out); //关闭out所指文件
}</pre>
<pre>//按十进制和字符显示文件代码，若遇不可示字符就用井号"#"字符代替之。
//程序名为：dumpf.c
//执行时可用：dumpf filename1 形式的命令行运行。
// File dump program.
#include &lt;stdio.h&gt;
void main(int argc,char *argv[])
{
    char str[9];
    int ch,count,i;
    FILE *fp;
    if(argc!=2)
    {
        printf("Error format,Usage: dumpf filename\n");
        return;
    }
    if((fp=fopen(argv[1],"r"))==NULL)
    {
        printf("The file %s can not be opened.\n",argv[1]);
        return;
    }
    count=0;
    do{
        i=0;
        //按八进制输出第一列，作为一行八个字节的首地址
        printf("%06o: ",count*8);
        do{
            // 从打开的文件中读取一个字符
            ch=fgetc(fp);
            // 按十进制方式输出这个字符的ASCII码
            printf("%4d",ch);
            // 如果是不可示字符就用"#"字符代替
            if(ch&lt;' '||ch&gt;'~') str[i]='#';
            // 如果是可示字符，就将它存入数组str以便形成字符串
            else str[i]=ch;
            // 保证每一行输出八个字符
            if(++i==8) break;
        }while(ch!=EOF); // 遇到文件尾标志，结束读文件操作
        str[i]='\0'; // 在数组str加字符串结束标志
        for(;i&lt;8;i++) printf(" "); // 一行不足八个字符用空格填充
        printf(" %s\n",str); // 输出字符串
        count++; // 准备输出下一行
    }while(ch!=EOF); // 直到文件结束
    fclose(fp); // 关闭fp所指文件
}</pre>
<h3>3. 从文件中读取一个字符串</h3>
<p>1． 函数原型：<strong>char *fgets(char *str,int n,FILE *fp)</strong><br />
2． 功能说明<br />
　　从由fp指出的文件中读取n-1个字符，并把它们存放到由str指出的字符数组中去，最后加上一个字符串结束符'\0'。<br />
3． 参数说明<br />
　　str：接收字符串的内存地址，可以是数组名，也可以是指针。<br />
　　n： 指出要读取字符的个数。<br />
　　fp：这是个文件指针，指出要从中读取字符的文件。<br />
4． 返回值</p>
<p>正常返回：返回字符串的内存首地址，即str的值。<br />
非正常返回：返回一个NULL值，此时应当用feof()或ferror()函数来判别是读取到了文件尾，还是发生了错误。例如，要从"写打开"文件中读取字符串，将<br />
发生错误而返回一个NULL值。</p>
<h3>4. 写一个字符串到文件中去</h3>
<p>1． 函数原型：<strong>int fputs(char *str,FILE *fp)</strong><br />
<br />2． 功能说明<br />
　　把由str指出的字符串写入到fp所指的文件中去。<br />
3． 参数说明<br />
　　str：指出要写到文件中去的字符串。<br />
　　fp：这是个文件指针，指出字符串要写入其中的文件。<br />
4． 返回值<br />
　　正常返回： 写入文件的字符个数，即字符串的长度。<br />
　　非正常返回：返回一个NULL值，此时应当用feof()或ferror()函数来判别是读取到了文件尾，还是发生了错误。例如，要往一个"读打开" 文件中写字符串时，<br />
会发生错误而返回一个NULL值。</p>
<pre>//以下程序将一个文件的内容附加到另一个文件中去。
//程序名：linkfile.c
//执行时可用：linkfile filename1 filename2形式的命令行运行，将文件filename2的内容附加在文件filename1之后。
// file linked program.
#include &lt;stdio.h&gt;
#define SIZE 512
void main(int argc,char *argv[])
{
    char buffer[SIZE];
    FILE *fp1,*fp2;
    if(argc!=3)
    {
        printf("Usage: linkfile filename1 filename2\n");
        return;
    }
    // 按追加方式打开argv[1] 所指文件
    if((fp1=fopen(argv[1],"a"))==NULL)
    {
        printf("The file %s can not be opened.\n",argv[1]);
        return;
    }
    if((fp2=fopen(argv[2],"r"))==NULL)
    {
        printf("The file %s can not be opened.\n",argv[2]);
        return;
    }
    // 读入一行立即写出，直到文件结束
    while(fgets(buffer,SIZE,fp1)!=NULL)
        printf("%s\n",buffer);
    while(fgets(buffer,SIZE,fp2)!=NULL)
        fputs(buffer,fp1);
    fclose(fp1);
    fclose(fp2);
    if((fp1=fopen(argv[1],"r"))==NULL)
    {
        printf("The file %s can not be opened.\n",argv[1]);
        return;
    }
    while(fgets(buffer,SIZE,fp1)!=NULL)
        printf("%s\n",buffer);
    fclose(fp1);
}</pre>
<h3>5. 往文件中写格式化数据</h3>
<p>1．函数原型：<strong>int fprintf(FILE *fp,char *format,arg_list)</strong><br />
<br />2．功能说明<br />
　　将变量表列（arg_list）中的数据，按照format指出的格式，写入由fp指定的文件。fprintf()函数与printf()函数的功能相同，只是printf()函数是将数据写入屏幕文件（stdout）。<br />
3．参数说明<br />
　　fp：这是个文件指针，指出要将数据写入的文件。<br />
　　format：这是个指向字符串的字符指针，字符串中含有要写出数据的格式，所以该字符串成为格式串。格式串描述的规则与printf()函数中的格式串相同。<br />
arg_list：是要写入文件的变量表列，各变量之间用逗号分隔。<br />
4．返回值：无。</p>
<pre>// 下列程序的执行文件为display.exe，执行时键入命令行：
//　　　display [-i][-s] filename
// 下面的表格列出了命令行参数的含义及其功能：

//存储文件名：save.txt
//程序代码如下：
// file display program.
#include &lt;stdio.h&gt;
void main()
{
    char name[10];
    int nAge,nClass;
    long number;
    FILE *fp;
    if((fp=fopen("student.txt","w"))==NULL)
    {
        printf("The file %s can not be opened.\n","student.txt");
        return;
    }
    fscanf(stdin,"%s %d %d %ld",name,&amp;nClass,&amp;nAge,&amp;number);
    fprintf(fp,"%s %5d %4d %8ld",name,nClass,nAge,number);
    fclose(fp);
    if((fp=fopen("student.txt","r"))==NULL)
    {
        printf("The file %s can not be opened.\n","student.txt");
        return;
    }
    fscanf(fp,"%s %d %d %ld",name,&amp;nClass,&amp;nAge,&amp;number);
    printf("name nClass nAge number\n");
    fprintf(stdout,"%-10s%-8d%-6d%-8ld\n",name,nClass,nAge,number);
    fclose(fp);
}</pre>
<p><strong>fscanf  从一个流中执行格式化输入</strong><br />
表头文件：#include&lt;stdio.h&gt;<br />
函数原型：<strong>int fscanf(FILE *stream, char *format[,argument...]);</strong><br />
FILE* 一个FILE型的指针<br />
char* 格式化输出函数，和scanf里的格式一样<br />
返回值：成功时返回转换的字节数，失败时返回一个负数<br />
fp = fopen("/local/test.c","a+");<br />
fscanf(fp,"%s",str);</p>
<p><strong>fdopen（将文件描述词转为文件指针）</strong><br />
相关函数 fopen，open，fclose<br />
表头文件 #include&lt;stdio.h&gt;<br />
定义函数 <strong>FILE * fdopen(int fildes,const char * mode);</strong><br />
函数说明 fdopen()会将参数fildes 的文件描述词，转换为对应的文件指针后返回。参数mode 字符串则代表着文件指针的流形态，此形态必须和原先文件描述词读写模式相同。关于mode 字符串格式请参考fopen()。<br />
返回值 转换成功时返回指向该流的文件指针。失败则返回NULL，并把错误代码存在errno中。</p>
<pre>#include&lt;stdio.h&gt;
main()
{
FILE * fp =fdopen(0,”w+”);
fprintf(fp,”%s/n”,”hello!”);
fclose(fp);
}
执行 hello!</pre>
<p><strong>fflush（更新缓冲区）</strong><br />
相关函数 write，fopen，fclose，setbuf<br />
表头文件 #include&lt;stdio.h&gt;<br />
定义函数<strong> int fflush(FILE* stream);</strong><br />
函数说明 fflush()会强迫将缓冲区内的数据写回参数stream指定的文件中。如果参数stream为NULL，fflush()会将所有打开的文件数据更新。<br />
返回值 成功返回0，失败返回EOF，错误代码存于errno中。<br />
错误代码 EBADF 参数stream 指定的文件未被打开，或打开状态为只读。其它错误代码参考write（）。</p>
<p><strong>fileno（返回文件流所使用的文件描述词）</strong><br />
相关函数 open，fopen<br />
表头文件 #include&lt;stdio.h&gt;<br />
定义函数 <strong>int fileno(FILE * stream);</strong><br />
函数说明 fileno()用来取得参数stream指定的文件流所使用的文件描述词。<br />
返回值 返回文件描述词。</p>
<pre>#include&lt;stdio.h&gt;
main()
{
FILE * fp;
int fd;
fp=fopen(“/etc/passwd”,”r”);
fd=fileno(fp);
printf(“fd=%d/n”,fd);
fclose(fp);
}
执行 fd=3</pre>
<h3>6. 以二进制形式读取文件中的数据</h3>
<p>1． 函数原型：<strong>int fread(void *buffer,unsigned sife,unsigned count,FILE *fp)</strong><br />
<br />2． 功能说明<br />
　　从由fp指定的文件中，按二进制形式将sife*count个数据读到由buffer指出的数据区中。<br />
3． 参数说明</p>
<pre>buffer：这是一个void型指针，指出要将读入数据存放在其中的存储区首地址。
sife：指出一个数据块的字节数，即一个数据块的大小尺寸。
count：指出一次读入多少个数据块（sife）。
fp：这是个文件指针，指出要从其中读出数据的文件。</pre>
<p>4．返回值</p>
<p>　　正常返回：实际读取数据块的个数，即count。</p>
<p>　　异常返回：如果文件中剩下的数据块个数少于参数中count指出的个数，或者发生了错误，返回0值。此时可以用feof()和ferror()来判定到底出现了什么情况。</p>
<pre>#include&lt;stdio.h&gt;
#define nmemb 3
struct test
{
    char name[20];
    int size;
}s[nmemb];
int main()
{
    FILE * stream;
    int i;
    stream = fopen(“/tmp/fwrite”,”r”);
    fread(s,sizeof(struct test),nmemb,stream);
    fclose(stream);
    for(i=0;i&lt;nmemb;i++)
        printf("name[%d]=%-20s:size[%d]=%d/n",i,s.name,i,s.size);
    return 0;
}

执行结果：
name[0]=Linux! size[0]=6
name[1]=FreeBSD! size[1]=8
name[2]=Windows2000 size[2]=11</pre>
<h3>7. 以二进制形式写数据到文件中去</h3>
<p>1． 函数原型：<strong>int fwrite(void *buffer,unsigned sife,unsigned count,FILE *fp)</strong><br />
2． 功能说明<br />
　　按二进制形式，将由buffer指定的数据缓冲区内的sife*count个数据写入由fp指定的文件中去。<br />
3． 参数说明
<pre>buffer：这是一个void型指针，指出要将其中数据输出到文件的缓冲区首地址。
sife：指出一个数据块的字节数，即一个数据块的大小尺寸。
count：一次输出多少个数据块（sife）。
fp：这是个文件指针，指出要从其中读出数据的文件。</pre>
<p>4．返回值</p>
<p>　　正常返回：实际输出数据块的个数，即count。</p>
<p>　　异常返回：返回0值，表示输出结束或发生了错误。</p>
<pre>#include &lt;stdio.h&gt;
#define SIZE 4
struct worker
{ int number;
    char name[20];
    int age;
};
void main()
{
    struct worker wk;
    int n;
    FILE *in,*out;
    if((in=fopen("file1.txt","rb"))==NULL)
    {
        printf("The file %s can not be opened.\n","file1.txt");
        return;
    }
    if((out=fopen("file2.txt","wb"))==NULL)
    {
        printf("The file %s can not be opened.\n","file2.txt");
        return;
    }
    while(fread(&amp;wk,sizeof(struct worker),1,in)==1)
        fwrite(&amp;wk,sizeof(struct worker),1,out);
    fclose(in);
    fclose(out);
}</pre>
<pre>#include &lt;stdio.h&gt;
#include &lt;stdlib.h&gt;
#include &lt;string.h&gt;
#define set_s(x,y) {strcpy(s[x].name,y);s[x].size=strlen(y);}
#define nmemb 3
struct test
{
    char name[20];
    int size;
}s[nmemb];

main()
{
    FILE * stream;
    set_s(0,"Linux!");
    set_s(1,"FreeBSD!");
    set_s(2,"Windows2000.");
    stream=fopen("fwrite","w");
    fwrite(s,sizeof(struct test),nmemb,stream);
    fclose(stream);
}

执行 参考fread（）。</pre>

<h3>8. 以二进制形式读取一个整数</h3>
<p>1． 函数原型：<strong>int getw(FILE *fp)</strong><br />
<br />2． 功能说明<br />
　　从由fp指定的文件中，以二进制形式读取一个整数。<br />
3． 参数说明<br />
　　fp：是文件指针。<br />
4． 返回值<br />
　　正常返回：所读取整数的值。<br />
　　异常返回：返回EOF，即-1。由于读取的整数值有可能是-1，所以必须用feof()或ferror()来判断是到了文件结束，还是出现了一个出错。</p>
<pre>#include &lt;stdio.h&gt;
void main(int argc,char *argv[])
{
    int i,sum=0;
    FILE *fp;
    if(argc!=2)
    {
        printf("Command error,Usage: readfile filename\n");
        exit(1);
    }
    if(!(fp=fopen(argv[1],"rb")))
    {
        printf("The file %s can not be opened.\n",argv[1]);
        exit(1);
    }
    for(i=1;i&lt;=10;i++) sum+=getw(fp);
    printf("The sum is %d\n",sum);
    fclose(fp);
}</pre>
<h3>9. 以二进制形式存贮一个整数</h3>
<p>1．函数原型：<strong>int putw(int n,FILE *fp)</strong><br />
<br />2． 功能说明<br />
　以二进制形式把由变量n指出的整数值存放到由fp指定的文件中。<br />
3． 参数说明<br />
　n：要存入文件的整数。<br />
　fp：是文件指针。<br />
4． 返回值<br />
　正常返回：所输出的整数值。<br />
　异常返回：返回EOF，即-1。由于输出的整数值有可能是-1，所以必须用feof()或ferror()来判断是到了文件结束，还是出现了一个出错。</p>
<pre>#include &lt;stdio.h&gt;
void main(int argc,char *argv[])
{
    int i;
    FILE *fp;
    if(argc!=2)
    {
        printf("Command error,Usage: writefile filename\n");
        return;
    }

    if(!(fp=fopen(argv[1],"wb")))
    {
        printf("The file %s can not be opened.\n",argv[1]);
        return;
    }
    for(i=1;i&lt;=10;i++) printf("%d\n", putw(i,fp));
    fclose(fp);
}</pre>
<h2>文件状态检查</h2>
<h3>1. 文件结束</h3>
<p>（1） 函数原型：<strong>int feof(FILE *fp)</strong><br />
<br />（2） 功能说明<br />
　　　该函数用来判断文件是否结束。<br />
（3） 参数说明<br />
　　　fp：文件指针。<br />
（4） 返回值<br />
　　　0：假值，表示文件未结束。<br />
　　　1：真值，表示文件结束。</p>
<pre>#include &lt;stdio.h&gt;
void main(int argc,char *argv[])
{
    FILE *in,*out;
    char ch;
    if(argc!=3)
    {
        printf("Usage: copyfile filename1 filename2\n");
        return;
    }
    if((in=fopen(argv[1],"rb"))==NULL)
    {
        printf("The file %s can not be opened.\n",argv[1]);
        return;
    }
    if((out=fopen(argv[2],"wb"))==NULL)
    {
        printf("The file %s can not be opened.\n",argv[2]);
        return;
    }
    while(!feof(in))
    {
        ch=fgetc(in);
        if(ferror(in))
        {
            printf("read error!\n");
            clearerr(in);
        }
        else
        {
            fputc(ch,out);
            if(ferror(out))
            {
                printf("write error!\n");
                clearerr(out);
            }
        }
    }
    fclose(in);
    fclose(out);
}</pre>
<h3>2. 文件读/写出错</h3>
<p>（1） 函数原型：<strong>int ferror(FILE *fp)</strong><br />
<br />（2） 功能说明<br />
　　　检查由fp指定的文件在读写时是否出错。<br />
（3） 参数说明<br />
　　　fp：文件指针。<br />
（4） 返回值<br />
　　　0：假值，表示无错误。<br />
　　　1：真值，表示出错。</p>
<h3>3. 清除文件错误标志</h3>
<p>（1） 函数原型：<strong>void clearerr(FILE *fp)</strong><br />
<br />（2） 功能说明<br />
　　　清除由fp指定文件的错误标志。<br />
（3） 参数说明<br />
　　　fp：文件指针。<br />
（4） 返回值：无。</p>
<pre>#include &lt;stdio.h&gt;
void main(int argc,char *argv[])
{
    FILE *in,*out;
    char ch;
    if(argc!=3)
    {
        printf("Usage: copyfile filename1 filename2\n");
        return;
    }
    if((in=fopen(argv[1],"rb"))==NULL)
    {
        printf("The file %s can not be opened.\n",argv[1]);
        return;
    }
    if((out=fopen(argv[2],"wb"))==NULL)
    {
        printf("The file %s can not be opened.\n",argv[2]);
        return;
    }
    while(!feof(in))
    {
        ch=fgetc(in);
        if(ferror(in))
        {
            printf("read error!\n");
            clearerr(in);
        }
        else
        {
            fputc(ch,out);
            if(ferror(out))
            {
                printf("write error!\n");
                clearerr(out);
            }
        }
    }
    fclose(in);
    fclose(out);
}</pre>
<h3>4. 了解文件指针的当前位置</h3>
<p>（1） 函数原型：<strong>long ftell(FILE *fp)</strong><br />
<br />（2） 功能说明<br />
　　　取得由fp指定文件的当前读/写位置，该位置值用相对于文件开头的位移量来表示。<br />
（3） 参数说明<br />
　　　fp：文件指针。<br />
（4） 返回值<br />
　　　正常返回：位移量（这是个长整数）。<br />
　　　异常返回：-1，表示出错。<br />
（5） 实例</p>
<h2>文件定位</h2>
<h3>1. 反绕</h3>
<p>（1） 函数原型：<strong>void rewind(FILE *fp)</strong><br />
<br />（2） 功能说明<br />
　　　使由文件指针fp指定的文件的位置指针重新指向文件的开头位置。<br />
（3） 参数说明<br />
　　　fp：文件指针。<br />
（4） 返回值：无。</p>
<pre>#include &lt;stdio.h&gt;
void main()
{
    FILE *in,*out;
    in=fopen("filename1","r");
    out=fopen("filename2","w");
    while(!feof(in)) fputc(fgetc(in),out);
    rewind(out);
    while(!feof(in)) putchar(fgetc(in));
    fclose(in);
    fclose(out);
}
</pre>
<h3>2. 随机定位：移动文件流的读写位置</h3>
<p>（1） 函数原型：<strong>int fseek(FILE *fp,long offset,int base)</strong><br />
<br />（2） 功能说明<br />
　　　使文件指针fp移到基于base的相对位置offset处。<br />
（3）参数说明<br />
　　　fp：文件指针。<br />
　　　offset：相对base的字节位移量。这是个长整数，用以支持大于64KB的文件。<br />
　　　base：文件位置指针移动的基准位置，是计算文件位置指针位移的基点。ANSI C定义了base的可能取值，以及这些取值的符号常量。</p>
<p>（4）返回值</p>
<p>　　正常返回：当前指针位置。<br />
　　异常返回：-1，表示定位操作出错。</p>
<p>下列是较特别的使用方式:<br />1) 欲将读写位置移动到文件开头时:fseek(FILE *stream,0,SEEK_SET);<br />
2) 欲将读写位置移动到文件尾时:fseek(FILE *stream,0,0SEEK_END);<br />返回值 当调用成功时则返回0，若有错误则返回-1，errno会存放错误代码。<br />附加说明 fseek()不像lseek()会返回读写位置，因此必须使用ftell()来取得目前读写的位置。</p>
<pre>#include &lt;stdio.h&gt;
#include &lt;string.h&gt;
struct std_type
{
    int num;
    char name[20];
    int age;
    char class;
}stud;
int cstufile()
{
    int i;
    FILE *fp;
    if((fp=fopen("stufile","wb"))==NULL)
    {
        printf("The file can't be opened for write.\n");
        return 0;
    }
    for(i=1;i&lt;=100;i++)
    {
        stud.num=i;
        strcpy(stud.name,"aaaa");
        stud.age=17;
        stud.class='8';
        fwrite(&amp;stud,sizeof(struct std_type),1,fp);
    }
    fclose(fp);
    return 1;
}
void main()
{
    int n;
    FILE *fp;
    if(cstufile()==0) return;
    if((fp=fopen("stufile","rb"))==NULL)
    {
        printf("The file can not be opened.\n");
        return;
    }
    for(n=0;n&lt;100;n+=2)
    {
        fseek(fp,n*sizeof(struct std_type),SEEK_SET);
        fread(&amp;stud,sizeof(struct std_type),1,fp);
        printf("%10d%20s%10d%4c\n",stud.num,stud.name,stud.age,stud.class);
    }
    fclose(fp);
}</pre>
<pre>#include &lt;stdio.h&gt;
#include &lt;stdlib.h&gt;

#include&lt;stdio.h&gt;
void main()
{
    FILE * stream;
    long offset;
    fpos_t pos;
    stream=fopen(“/etc/passwd”,”r”);
    fseek(stream,5,SEEK_SET);
    printf("offset=%d/n",ftell(stream));
    rewind(stream);
    fgetpos(stream,&amp;pos);
    printf("offset=%d/n",pos);
    pos=10;
    fsetpos(stream,&amp;pos);
    printf("offset = %d/n",ftell(stream));
    fclose(stream);
}
执行 结果
offset = 5
offset =0
offset=10</pre>
<p>ftell（取得文件流的读取位置）<br />相关函数 fseek，rewind，fgetpos，fsetpos<br />表头文件 #include&lt;stdio.h&gt;<br />定义函数 long ftell(FILE * stream);<br />函数说明 ftell()用来取得文件流目前的读写位置。参数stream为已打开的文件指针。<br />返回值 当调用成功时则返回目前的读写位置，若有错误则返回-1，errno会存放错误代码。<br />错误代码 EBADF 参数stream无效或可移动读写位置的文件流。<br /><strong>范例 参考fseek()。</strong></p>
<h2>关于exit()函数</h2>
<p>1． 函数原型:<strong>void exit(int status)</strong><br />
<br />2． 功能说明:exit()函数使程序立即终止执行，同时将缓冲区中剩余的数据输出并关闭所有已经打开的文件。<br />
3． 参数说明:status：为0值表示程序正常终止，为非0值表示一个定义错误。<br />
4． 返回值:无。</p>
<h2>* 关于feof()函数</h2>
<p>1． 函数原型:<strong>int feof(FILE *fp)</strong><br />
2． 功能说明<br />
　 　在文本文件（ASCII文件）中可以用值为-1的符号常量EOF来作为文件的结束符。但是在二进制文件中-1往往可能是一个有意义的数据，因此不能用它 来作为文件的结束标志。为了能有效判别文件是否结束，ANSI C提供了标准函数feof()，用来识别文件是否结束。<br />
3． 参数说明:fp：文件指针。<br />
4． 返回值<br />
　　返回为非0值：已到文件尾。<br />
　　返回为0值：表示还未到文件尾。</p>
<h1>C语言的直接I\O文件操作</h1>
<p>这是C提供的另一种文件操作，它是通过直接存/取文件来完成对文件的处理，而上篇所说流式文件操作是通过缓冲区来进行；流式文件操作是围绕一个FILE指针来进行，而此类文件操作是围绕一个文件的“句柄”来进行，什么是句柄呢？它是一个整数，是系统用来标识一个文件(在WINDOWS中，句柄的概念扩展到所有设备资源的标识)的唯一的记号。此类文件操作常用的函数如下表，这些函数及其所用的一些符号在io.h和fcntl.h中定义，在使用时要加入相应的头文件。</p>
<pre>函数             说明
open()         打开一个文件并返回它的句柄
close()        关闭一个句柄
lseek()        定位到文件的指定位置
read()         块读文件
write()        块写文件
eof()          测试文件是否结束
filelength()   取得文件长度
rename()       重命名文件
chsize()       改变文件长度</pre>
<p><strong>1.open()</strong><br />
　　打开一个文件并返回它的句柄，如果失败，将返回一个小于0的值，原型是int open(const char *path, int access [, unsigned mode]); 参数path是要打开的文件名，access是打开的模式，mode是可选项。表示文件的属性，主要用于UNIX系统中，在DOS/WINDOWS这个参数没有意义。其中文件的打开模式如下表。<br />
符号 含义 符号 含义 符号 含义<br />
O_RDONLY 只读方式 O_WRONLY 只写方式 O_RDWR 读/写方式<br />
O_NDELAY 用于UNIX系统 O_APPEND 追加方式 O_CREAT 如果文件不存在就创建<br />
O_TRUNC 把文件长度截为0 O_EXCL 和O_CREAT连用，如果文件存在返回错误 O_BINARY 二进制方式 O_TEXT 文本方式　<br />
对于多个要求，可以用"|"运算符来连接，如O_APPEND|O_TEXT表示以文本模式和追加方式打开文件。<br />
例：inthandle=open("c:\\msdos.sys",O_BINARY|O_CREAT|O_WRITE)</p>
<p><strong>2.close()</strong><br />
关闭一个句柄，原型是int close(int handle);如果成功返回0<br />
例：close(handle)</p>
<p><strong>3.lseek()</strong><br />
　　定位到指定的位置，原型是：long lseek(int handle,long offset, int fromwhere);参数offset是移动的量，fromwhere是移动的基准位置，取值和前面讲的fseek()一样，SEEK_SET：文件首部；SEEK_CUR：文件当前位置；SEEK_END：文件尾。此函数返回执行后文件新的存取位置。<br />
例：<br />
　　lseek(handle,-1234L,SEEK_CUR);//把存取位置从当前位置向前移动1234个字节。<br />
　　x=lseek(hnd1,0L,SEEK_END);//把存取位置移动到文件尾，x=文件尾的位置即文件长度</p>
<p><strong>4.read()</strong><br />
　　从文件读取一块，原型是int read(int handle, void*buf, unsigned len);参数buf保存读出的数据，len是读取的字节。函数返回实际读出的字节。<br />
例：char x[200];read(hnd1,x,200);</p>
<p><strong>5.write()</strong><br />
　　写一块数据到文件中，原型是int write(int handle,void *buf, unsigned len);参数的含义同read()，返回实际写入的字节。<br />
例：char x[]="I LoveYou";write(handle,x,strlen(x));</p>
<p><strong>7.eof()</strong><br />
　　类似feof()，测试文件是否结束，是返回1，否则返回0;原型是：inteof(int handle);<br />
例：while(!eof(handle1)){……};</p>
<p><strong>8.filelength()</strong><br />
　　返回文件长度，原型是long filelength(int handle);相当于lseek(handle,0L,SEEK_END)<br />
例：long x=filelength(handle);</p>
<p><strong>9.rename()</strong><br />
　　重命名文件，原型是int rename(const char*oldname, const char *newname); 参数oldname是旧文件名，newname是新文件名。成功返回0<br />
例：rename("c:\\config.sys","c:\\config.w40");</p>
<p><strong>10.chsize();</strong><br />
　　改变文件长度，原型是int chsize(int handle, longsize);参数size表示文件新的长度，成功返回0，否则返回-1，如果指定的长度小于文件长度，则文件被截短；如果指定的长度大于文件长度，则在文件后面补''\0''。<br />
例：chsize(handle,0x12345);<br />
如果熟悉汇编可能会发现这种方式和汇编语言的DOS功能调用句柄式文件操作很像，比如open()就像DOS服务的3CH号功能调用，其实这种操作还有两种类型的函数就是直接用DOS功能来完成的，如_open()，_dos_open()等等。有兴趣可自已查询BCB的帮助。<br />
　　同流式文件操作相同，这种也提供了Unicode字符操作的函数，如_wopen()等等，用于9X/NT下的宽字符编程，有兴趣可自已查询BCB的帮助。<br />
　　另外，此种操作还有lock(),unlock(),locking()等用于多用户操作的函数，但在BCB中用得并不多，我就不介绍了，但如果要用C来写CGI，这些就必要的常识了，如果你有这方面的要求，那就得自已好好看帮助了.</p>
<p><strong>setbuffer（设置文件流的缓冲区）</strong><br />
相关函数 setlinebuf，setbuf，setvbuf<br />
表头文件 #include&lt;stdio.h&gt;<br />
定义函数 void setbuffer(FILE * stream,char * buf,size_t size);<br />
函数说明 在打开文件流后，读取内容之前，调用setbuffer()可用来设置文件流的缓冲区。参数stream为指定的文件流，参数buf指向自定的缓冲区起始地址，参数size为缓冲区大小。<br />
返回值<strong><br /></strong></p>
<p><strong>setlinebuf（设置文件流为线性缓冲区）</strong><br />
相关函数 setbuffer，setbuf，setvbuf<br />
表头文件 #include&lt;stdio.h&gt;<br />
定义函数 void setlinebuf(FILE * stream);<br />
函数说明 setlinebuf()用来设置文件流以换行为依据的无缓冲IO。相当于调用:setvbuf(stream,(char * )NULL,_IOLBF,0);请参考setvbuf()。<br />
返回值</p>
<p><strong>setvbuf（设置文件流的缓冲区）</strong><br />
相关函数 setbuffer，setlinebuf，setbuf<br />
表头文件 #include&lt;stdio.h&gt;<br />
定义函数 int setvbuf(FILE * stream,char * buf,int mode,size_t size);<br />
函数说明 在打开文件流后，读取内容之前，调用setvbuf()可以用来设置文件流的缓冲区。参数stream为指定的文件流，参数buf指向自定的缓冲区起始地址，参数size为缓冲区大小，参数mode有下列几种<br />
_IONBF 无缓冲IO<br />
_IOLBF 以换行为依据的无缓冲IO<br />
_IOFBF 完全无缓冲IO。如果参数buf为NULL指针，则为无缓冲IO。<br />
返回值</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-27 03:19:12</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/%e5%87%bd%e6%95%b0/" title="函数">函数</a>, <a href="https://www.iamivan.net/tag/ios/" title="ios">ios</a>, <a href="https://www.iamivan.net/tag/file/" title="file">file</a>, <a href="https://www.iamivan.net/tag/void/" title="void">void</a>, <a href="https://www.iamivan.net/tag/open/" title="open">open</a>, <a href="https://www.iamivan.net/tag/stream/" title="stream">stream</a>, <a href="https://www.iamivan.net/tag/fopen/" title="fopen">fopen</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>C 和 C++ 文件操作详解的相关文章</h3>

						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/7M0g6Db.html" rel="bookmark">使用技巧：对Java编程中的文件操作详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				编程|技巧|详解 一.获得控制台用户输入的信息 /** *//**获得控制台用户输入的信息 * @return * @throws IOException */ public String getInputMessage() throws IOException...{ System.out.println(&quot;请输入您的命令∶&quot;); byte buffer[]=new byte[1024]; int count=System.in.read(buffer); char[] ch=new			</div>
		</article>
	</section>
						<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bQL868z.html" rel="bookmark">Android 文件操作详解及简单实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Android 文件操作详解 Android 的文件操作说白了就是Java的文件操作的处理.所以如果对Java的io文件操作比较熟悉的话,android的文件操作就是小菜一碟了.好了,话不多说,开始今天的正题吧. 先从一个小项目入门吧 首先是一个布局文件,这一点比较的简单,那就直接上代码吧. &lt;LinearLayout xmlns:android=&quot;http://schemas.android.com/apk/res/android&quot; xmlns:tools=&quot;http			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5WG5Rb.html" rel="bookmark">Java I&sol;O技术之文件操作详解&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在java程序设计中,I/O操作是通过java.io包中的类和接口来实现的,因此,我们第一步要做的就是import这个包. java.io提供了一个File类,这是类很容易让人产生误会,它表示的是一个文件名或者目录名,而不是文件本身,所以通过这个类没法对文件里面的数据进行操作.File类提供了一序列对文件操作的功能:删除文件,创建目录,查询文件大小等等.要想对文件数据进行操作那就需要流对象了,在这里就暂时不做介绍. 下面通过一个叫做FileExtension类来对File类中的各种操作进行封装,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MY2edep.html" rel="bookmark">Android的file文件操作详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				  android的文件操作要有权限: 判断SD卡是否插入 Environment.getExternalStorageState().equals( android.os.Environment.MEDIA_MOUNTED); 获得sd卡根目录 File skRoot = Environment.getExternalStorageDirectory(); 获得私有根目录 File fileRoot = Context.getFilesDir()+&quot;&quot;; 确定或获得文件夹和文件路径			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mrvr7xM.html" rel="bookmark">使用Python进行稳定可靠的文件操作详解&lowbar;python</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				考虑下述Python代码片段.对文件中的数据进行某些操作,然后将结果保存回文件中: 复制代码 代码如下: with open(filename) as f:   input = f.read()output = do_something(input)with open(filename, 'w') as f:   f.write(output) 看起来很简单吧?可能看起来并不像乍一看这么简单.我在产品服务器中调试应用,经常会出现奇怪的行为.这是我看过的失效模式的例子:失控的服务器进程溢出大量日志			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bBY5Yaz.html" rel="bookmark">lua文件操作详解&lowbar;Lua</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				I/O库提供两种不同的方式进行文件处理: io表调用方式 使用io表,io.open将返回指定文件的描述,并且所有的操作将围绕这个文件描述.io表同样提供三种预定义的文件描述io.stdin,io.stdout,io.stderr 文件句柄直接调用方式 即使用file:XXX()函数方式进行操作,其中file为io.open()返回的文件句柄.多数I/O函数调用失败时返回nil加错误信息,有些函数成功时返回nil IO io.close ([file]) io.flush () 相当于file:			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pLd6kRp.html" rel="bookmark">javascript中文件操作详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.功能实现核心:FileSystemObject 对象 其实,要在javascript中实现文件操作功能,主要就是依靠FileSystemobject对象. 二.FileSystemObject编程三部曲 使用FileSystemObject 对象进行编程很简单,一般要经过如下的步骤: 创建FileSystemObject对象.应用相关方法.访问对象相关属性 . (一)创建FileSystemObject对象 创建FileSystemObject对象的代码只要1行:  代码如下 复制代码 va			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MymRWEM.html" rel="bookmark">Android开发之文件操作详解</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文实例讲述了Android开发之文件操作.分享给大家供大家参考,具体如下: 目前,几乎所有的设备都会涉及到文件的操作,例如什么电脑,手机等设备.Android的文件操作和电脑是比较类似的,既可以存储在手机内置的存储器里也可以是sd卡.在这篇文章里主要介绍在手机内置存储器里的文件操作. 一. 开发流程 (1)界面的设计 (2)设计android的业务层 (3)单元测试 (4)设置android的控制器层 二. 开发步骤 (1)设计软件界面 &lt;?xml version=&quot;1.0&quot;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/Mr0QY4z.html" rel="bookmark">Node&period;js文件操作详解&lowbar;node&period;js</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Node有一组数据流API,可以像处理网络流那样处理文件,用起来很方便,但是它只允许顺序处理文件,不能随机读写文件.因此,需要使用一些更底层的文件系统操作. 本章覆盖了文件处理的基础知识,包括如何打开文件,读取文件某一部分,写数据,以及关闭文件. Node的很多文件API几乎是UNIX(POSIX)中对应文件API 的翻版,比如使用文件描述符的方式,就像UNIX里一样,文件描述符在Node里也是一个整型数字,代表一个实体在进程文件描述符表里的索引. 有3个特殊的文件描述符--1,2和3.他们分别			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/aM1jPap.html" rel="bookmark" class="title">小巧的php文档生成类</a>
					<div>
						在项目开发中发现对php的文档缺少管理,别人写了一个,功能不多 &lt;?php/*** 类名: doc* 描述: 文档生成类* 其他: 可以对目录进行过滤,设置好源目录后,请用绝对路径指定生成目录, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/XMl1oDp.html" rel="bookmark" class="title">思科PIX ASDM的安装与故障排除</a>
					<div>
						为了简化PIX防火墙配置,思科提供了自适应安全设备管理器(ASDM).自适应安全设备管理器为配置选择的PIX防火墙提供了一个功能强大的.使用方便的接口.(参见思科的文件或者网站上支持自适应安全设备管理 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpPe5vz.html" rel="bookmark" class="title">关于PHP中操作MySQL数据库的一些要注意的问题</a>
					<div>
						mysql|数据|数据库|问题 1. 分号的例外 对于 MySQL ,第一件你必须牢记的是它的每一行命令都是用分号 (;) 作为结束的,但--没有完全绝对的事,在这儿也是一样,当一行 MySQL 被插 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/9bBv39b.html" rel="bookmark" class="title">通过 iTextSharp 实现PDF 审核盖章</a>
					<div>
						最近需要做一个PDF自动审核盖章的工作,其实就是读取PDF,然后再最后一页加入一个审核章印图 片上去.看起来很简单,不过在开发过程中,还是遇到了一些问题,在这里记录一下. 主要遇到的问题是页面的旋转  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQPBjWz.html" rel="bookmark" class="title">安全使用网上银行全攻略</a>
					<div>
						随着股市的不断升温,以网上银行作为转账.支付手段的股民大幅增加.而且通过网上银行申购基金,还能享受费率优惠.但是,在享受网上银行带来便捷的同时,如何规避有可能遭到黑客的攻击而带来的经济损失? &quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5AElnp.html" rel="bookmark" class="title">CSS中值得记住的一些技巧</a>
					<div>
						  这篇文章主要介绍了CSS中值得记住的一些技巧,文中介绍的这些属性在平时的应用中虽然不是经常能够见到,但非常有效率,需要的朋友可以参考下 Box-sizing 尽管box-sizing在CSS3中才 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pm7oa5b.html" rel="bookmark" class="title">WPS2009如何为文档添加背景</a>
					<div>
						  WPS2009如何为文档添加背景           WPS是一款非常火的软件,那么WPS2009如何为文档添加背景?小编来告诉你! 许多人为文档添加背景的办法是插入图片,然后把它设置成衬于文字下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr33a6p.html" rel="bookmark" class="title">Word2007中如何插入和删除分节符？</a>
					<div>
						  在使用Word编辑的过程中有时我们会用到分节符,分节符是可用节 (节:文档的一部分,可在其中设置某些页面格式选项.若要更改例如行编号.列数或页眉和页脚等属性,请创建一个新的节.)在一页之内或两页之 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJZKjVz.html" rel="bookmark" class="title">数学工具mathematica符号工具栏不见了怎么调出？</a>
					<div>
						  数学工具mathematica符号工具栏不见了怎么调出? file(最上栏第一个)-&gt;palettes(灰线分开的第三部分, 第一个),然后选自己想要的就成了.你可以全调出来,然后再看到底哪 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zGJYlOp.html" rel="bookmark" class="title">Windows XP的六大忌讳</a>
					<div>
						  一.忌虚拟光驱 现在多数虚拟光驱在XP里是不稳定的,容易引起XP的死机,因为虚拟光驱不同于一般的软件:它通过特殊的机制,在&quot;设备管理器&quot;中骗过Windows,让Windows以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5o0l6b.html" rel="bookmark" class="title">上行带宽和下行带宽是什么意思？各有什么作用？</a>
					<div>
						  上行带宽和下行带宽,或者说上行速度和下行速度是什么意思?在设置路由器的限速,以及配置其它一些软件的时候经常遇到上行速度和下行速度,很多用户根本就不知道这两个所代表的意识,更不说配置了,下文将为大家 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pdE661z.html" rel="bookmark" class="title">Black Hat 2017：不容错过的七大主题演讲</a>
					<div>
						激动人心的Black Hat 2017美国黑帽大会即将拉开帷幕,列出今天这份重要演讲清单,来看看今年都涉及哪些主题. 今年的这些演讲将涵盖移动网络安全漏洞.入侵电子门锁到监控家庭网络流量等极为广泛的研 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvmAY9b.html" rel="bookmark" class="title">《C&plus;&plus;编程惯用法&mdash;&mdash;高级程序员常用方法和技巧》&mdash;&mdash;1&period;4　使用CRC卡片来辅助设计</a>
					<div>
						1.4 使用CRC卡片来辅助设计 由Kent Beck和Ward Cunningham设计的CRC卡片是一种用来帮助设计人员在设计阶段前期进行设计的工具,此时设计人员应该做的事情就是:从问题域中找到合 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmKkNwb.html" rel="bookmark" class="title">眼萌怎么用 眼萌视力测试的方法</a>
					<div>
						眼萌视力测试功能怎么用 在手机打开&quot;眼萌&quot;然后点击界面中的&quot;萌测试&quot;选项卡. 在我们点击之后会进入到萌测试面板,在此有多个选项,我们现在点击&quot;视力测试 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bQBy4GM.html" rel="bookmark" class="title">怎样根据一组gps坐标来找出其中的拐点</a>
					<div>
						问题描述 现在有一组gps经纬度坐标,现在我想计算出其中的拐点比如点(x1,y1)和(x2,y2)这两个点组成的线与(x2,y2)和(x3,y3)这两个点组成的线所组成的角度,如果大于一定的数值,就认 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Myew04M.html" rel="bookmark" class="title">团购网站究竟病因何在？</a>
					<div>
						从2011年下半年开始,不少人将团购行业的发展现状作为中国电子商务进入&quot;寒冬&quot;期的佐证之一:去年,团购从上半年狂热的&quot;千团大战&quot;迅速演变为下半年的&quot;批 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MWWK1qM.html" rel="bookmark" class="title">淘宝、搜狐博客屏蔽百度蜘蛛爬虫</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 据百度内部人士透露,百度电商平台将 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwJ4evp.html" rel="bookmark" class="title">C&num; 写的Winform页面下载程序 在没有抛出异常的情况下退出程序</a>
					<div>
						问题描述 C#写的Winform页面下载程序在没有抛出异常的情况下退出程序但是线程依然存在请问一下当正常与不正常的情况下,程序是不是都会通过CLoseing的事件退出程序呢谢谢~~!!在线等 解决方案 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNn9exM.html" rel="bookmark" class="title">使用AjaxControlToolkit中的 autocomplete控件报错</a>
					<div>
						问题描述 &quot;/&quot;应用程序中的服务器错误.未能加载文件或程序集&quot;AjaxMin,Version=4.97.4951.28478,Culture=neutral,Public ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnRjPjp.html" rel="bookmark" class="title">管理并购公司的八大要点</a>
					<div>
						著名科技文章作者托米奥·格侬(Tomio Geron)据对克里斯蒂安·塞格斯特拉尔(Kristian Segerstrale)的采访,撰写一篇文章,此文从八大方面就如何维护团队和让并购初创企业成功的方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M9xDWvb.html" rel="bookmark" class="title">ajax-J2EE 有没有类似apache tiles，但可以进行局部刷新的页面布局框架？</a>
					<div>
						问题描述 J2EE 有没有类似apache tiles,但可以进行局部刷新的页面布局框架? 除了iframe.ajax,还有其他能实现局部刷新的解决方案吗? 解决方案 除了iframe.ajax,还有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zOnJE9p.html" rel="bookmark" class="title">Bootstrap安装环境配置教程分享&lowbar;javascript技巧</a>
					<div>
						Bootstrap 安装是非常容易的.此文是本人的学习汇总,便于以后查询学习,同时也希望给大家带来帮助. 一.下载 Bootstrap您可以从 http://getbootstrap.com/ 上下载 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlmdEVp.html" rel="bookmark" class="title">js移除事件 js绑定事件实例应用&lowbar;javascript技巧</a>
					<div>
						复制代码 代码如下: /** * @description 事件绑定,兼容各浏览器 * @param target 事件触发对象 * @param type 事件 * @param func 事件处理 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MNvAqPM.html" rel="bookmark" class="title">SQL Server查询语句运行指标值监测学习总结</a>
					<div>
						前言 上一篇我们分析了查询优化器的工作方式,其中包括:查询优化器的详细运行步骤.筛选条件分析.索引项优化等信息. 本篇我们分析在我们运行的过程中几个关键指标值的检测. 通过这些指标值来分析语句的运行问 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7Qv7AM.html" rel="bookmark" class="title">javascript提取jstl中radio标签的值</a>
					<div>
						问题描述 我已经在csdn发了,在这就直接贴链接吧,希望斑竹谅解!http://topic.csdn.net/u/20110914/09/a55e9f09-f976-4593-b5c5-d75ff7f ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW7kgAM.html" rel="bookmark" class="title">怎样添加自定义表情&lpar;类似QQ的可以左右滑动的&rpar;</a>
					<div>
						问题描述 解决方案 表情是UI上处理的.1. 客户单维护一个字符串-表情对照表.2. 客户端发送消息时,字符串中有表情字符串,则ui上解析替换成表情图片.3. 客户端接收消息时,发现收到的消息中带有表 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYwaAb.html" rel="bookmark" class="title">Ceph分布式存储实战3&period;3　CRUSH关系分析</a>
					<div>
						3.3 CRUSH关系分析 从本质上讲,CRUSH算法是通过存储设备的权重来计算数据对象的分布的.在计算过程中,通过Cluster Map(集群映射).Data Distribution Policy ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvYVGWb.html" rel="bookmark" class="title">c&num; 用中文作为hashtable的键有没有什么问题</a>
					<div>
						问题描述 如题,HashTableht=newHashTable();ht[&quot;问题&quot;]=&quot;sdfsdf&quot;;想问下,这样在英文系统或是英文版的FRAMEWORK下 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEJl4oM.html" rel="bookmark" class="title">《Adobe Illustrator CS5中文版经典教程》&mdash;第0课0&period;16节 使用符号</a>
					<div>
						0.16 使用符号Adobe Illustrator CS5中文版经典教程符号是存储在&quot;符号&quot;面板中的可重复使用的图稿对象,下面使用图稿创建一个符号.有关符号的更详细信息,请参阅第 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvWnG1p.html" rel="bookmark" class="title">IOS信息重复</a>
					<div>
						问题描述 iOS信息重复 解决方案 在EaseMessageViewController.m类的viewdidload中的 [self tableViewDidTriggerHeaderRefresh ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.072 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
